#ifndef BUSTAGRAPHICSBUTTON_H
#define	BUSTAGRAPHICSBUTTON_H

#include "BustaGraphics.h"

/**
 * @class BustaGraphics
 * @brief contains methods for displaying graphics
 *
 */
enum BUTTON_ID {OK, CANCEL, 
class BustaGraphicsButton
{
	private:
		SDL_Rect myArea;
		SDL_Surface* myPressedSprite;
		SDL_Surface* myIdleSprite;
		bool myPressed;
		int myButtonID;

	public:
	
		BustaGraphiscButton(SDL_Rect area, int buttonID)
		{
			myArea = area;
			myButtonID = buttonID;
			myPressed = false;
		}
		
		/**
		* @brief 
		* @return the area of the button in SDL_Rect form
		*/
		SDL_Rect* getArea() { return &myArea; }
		int getButtonID() { return myButtonID; }
		bool isPressed() { return myPressed; }
		void setPressed(bool pressed) { myPressed = pressed; }
		
		void setSprites(SDL_Surface* pressedSprite, SDL_Surface* idleSprite) 
		{
			myPressedSprite = pressedSprite; 
			myIdleSprite = idleSprite; 
		}

		SDL_Surface* getSprite()
		{
			if(myPressed)
				return myPressedSprite;

			return myIdleSprite;
		}
}

#endif