/*	Filename:		BustaModelMPGameState.h
 *	Description:	Busta' Sandwich Multi-player GameState model.
 *
 */

#define NULL 0

#ifndef BUSTA_SANDWICH_MPGAMESTATE
#define BUSTA_SANDWICH_MPGAMESTATE

#include "BustaModelOpponent.h"
#include "BustaModelGameState.h"

/**
 * @class BustaModelMPGameState
 * @brief Multi-player Game State representation
 * 
 * Game state representation for MP opponents.  Contains Game State model for selected opponent, plus important info for other opponents
 */
class BustaModelMPGameState
{
	public:
		/**
		 * @brief Constructor
		 *
		 * Initializes variables
		 */
		BustaModelMPGameState();

		/**
		 * @brief Constructor
		 *
		 * Initializes variables
		 */
		BustaModelMPGameState(BustaModelGameState* gs, BustaModelOpponent** oppos, int n);

		/**
		 * @brief Destructor
		 * 
		 * Destructor
		 */
		~BustaModelMPGameState();


		/**
		 * @brief Gets opponent GameState
		 *
		 * Gets pointer to the GameState of highlighted opponent
		 */
		BustaModelGameState* getGameState();


		/**
		 * @brief Gets opponent
		 *
		 * Returns a pointer to the opponent in the nth location in the array
		 */
		BustaModelOpponent*  getOpponent(int n);



	private:
		int numopps;
		BustaModelGameState* opponentGS;
		BustaModelOpponent** opponents;
};

#endif
