/*	Filename:		BustaModelOpponent.h
 *	Description:	Busta' Sandwich Opponent model.
 *
 */

#ifndef BUSTA_SANDWICH_OPPONENT
#define BUSTA_SANDWICH_OPPONENT

#include "BustaModelTipJar.h"

/**
 * @class BustaModelOpponent
 * @brief Opponent model
 * 
 *	Opponent representation, has character, health, and tip jar
 */
class BustaModelOpponent
{
	public:
		/**
		 * @brief Constructor
		 *
		 * Initializes variables
		 */
		BustaModelOpponent();

		/**
		 * @brief Constructor
		 *
		 * Initializes variables
		 */
		BustaModelOpponent(int c, int h, int s);


		/**
		 * @brief Destructor
		 * 
		 *	Deletes tip jar
		 */
		~BustaModelOpponent();

		/**
		 * @brief Gets Character
		 *
		 * Returns int representing character ID, representation
		 */
		int getCharacter();

		/**
		 * @brief gets health of character
		 *
		 * Gets the health of the opponent
		 */
		int getHealth();

		/**
		 * @brief gets amount in tipjar
		 *
		 * returns int with current amount in opponent tip jar
		 */
		int getTips();

	private:
		int character;
		int health;
		BustaModelTipJar* tips; 
};

#endif