/*	Filename:		BustaModelPosition.h
 *	Description:	Busta' Sandwich Position model.
 *
 */

#ifndef BUSTA_SANDWICH_POSITION
#define BUSTA_SANDWICH_POSITION


/**
 * @class BustaModelPosition
 * @brief Position Model
 * 
 * Contains x and y coordinates for representing a board position
 *
 */
class BustaModelPosition
{
	public:
		/**
		 * @brief Constructor
		 *
		 * Initializes variables
		 */
		BustaModelPosition();

		/**
		 * @brief Constructor
		 *
		 * Initializes variables
		 */
		BustaModelPosition(int x, int y);


		/**
		 * @brief Destructor
		 *
		 * Destructor
		 */
		~BustaModelPosition();

		/**
		 * @brief Gets x position
		 *
		 * Gets x position
		 */
		int getX();

		/**
		 * @brief gets y position
		 *
		 * gets y position
		 */
		int getY();
		
		/**
		 * @brief sets x position
		 *
		 * sets x position
		 */
		void setX(int x);

		/**
		 * @brief sets y position
		 *
		 * sets y position
		 */
		void setY(int y);

	private:
		int x1;
		int y1;
};

#endif