/*	Filename:		BustaSandwichServer.cpp
 *	Description:	Main stand-alone server application for Busta' Sandwich
 *
 */

#include <stdio.h>
#include <string.h>

#include "BustaNetServer.h"

/* void Usage(char** argv)
 *
 *	Prints proper usage of the application (input parameters, etc)
 */
void Usage(char** argv)
{
	printf("Usage: %s [OPTION]\n", argv[0]);

	printf("-h\tHelp.\n");
	printf("-n name\tServer name.\n");
	printf("-s size\tMax server size.\n");
}

int main(int argc, char** argv)
{
	int AcceptRet, CharSelRet, GameRet;		// Return values of all server states
	char* initRet;							// Return value of server initialization
	char* newName;							// server's assigned name

	// Create instance of server
	BustaNetServer* server = new BustaNetServer();

	// Define Server Defaults
	newName = "BustaSandwich Server";
	server->setName(newName);			// default server name "BustaSandwich Server"
	server->setMaxClients(4);			// default 4 players
	server->setDebug(false);			// no debugging output

	// Parameters supplied
	if (argc > 1)
	{
		// Iterate across each parameter set server settings
		for (int i = 1; i < argc; i++)
		{
			if (strcmp(argv[i], "-h") == 0)							// Help Requested
			{
				Usage(argv);		// Print proper usage of applications
				return 0;
			}
			else if (strcmp(argv[i], "-d") == 0)					// Output Debug 
			{
				server->setDebug(true);
			}
			else if (strcmp(argv[i], "-n") == 0)					// Server Name
			{
				if (i == argc-1)
				{
					Usage(argv);	// Print proper usage of applications
					return 1;
				}

				server->setName(argv[i++]);
			}
			else if (strcmp(argv[i], "-s") == 0)					// Server Size
			{
				if (i == argc-1)
				{
					Usage(argv);	// Print proper usage of applications
					return 1;
				}

				int size_buf;
				sscanf(argv[++i],"%d",&size_buf);
				server->setMaxClients(size_buf);
			}
			else													// Invalid Parameter
			{
					printf("Invalid Parameter: %s\n", argv[i]);
					printf("Aborting\n");
					return 1;
			}
		}
	}

	// Initialize server
	server->init(65535);

	// Output settings used to stdio
	printf("Server Name: %s\n", server->getName());
	//printf("IP: %s\n",);
	//printf("Port: 65535\n);
	printf("Maximum Players Allowed: %d", server->getMaxClients());

	AcceptRet = server->setStateAccept();

	//for (;;)
	//{
	//	/* Accepting incoming client connections */
	//	AcceptRet = server->setStateAccept();

	//	// If error occurs, print to console and exit
	//	if (AcceptRet < 0)
	//	{
	//		printf("Error Connecting Clients\n");
	//		printf("Aborting\n");
	//		return 1;
	//	}

	//	/* Character Selection State */
	//	CharSelRet = server->setStateCharSelect();

	//	// If error occurs, print to console and exit
	//	if (CharSelRet < 0)
	//	{
	//		printf("Error During Character Selection\n");
	//		printf("Aborting\n");
	//		return 1;
	//	}
	//	else if (CharSelRet == 0)	// If less than two players remain on server
	//	{


	//	}
	//	else		// All characters have selected a character
	//	{


	//	}

	//	//GameRet = server->setStateGame();
	//	//if(...

	//}

	// Free Allocated Memory
	delete(server);

	return 0;
}
